/* [styx_lim.c] Scanner table for 'styx'  */

#include "scn_io.h"

#include "scn_imp.h"

/* scanner group 'styx' */

static long styxStaEdg[91] =
/* first edge per state */
{
          0,        35,        36,        37,        40,        42,
         43,        62,        75,       102,       116,       117,
        120,       125,       126,       133,       134,       160,
        165,       170,       173,       176,       179,       194,
        195,       223,       226,       233,       240,       243,
        246,       251,       254,       257,       260,       261,
        274,       287,       313,       320,       327,       345,
        348,       349,       352,       355,       358,       361,
        364,       382,       400,       403,       406,       409,
        412,       430,       448,       455,       458,       465,
        468,       486,       499,       512,       515,       528,
        531,       544,       553,       560,       579,       582,
        592,       603,       619,       623,       630,       635,
        651,       659,       672,       683,       692,       698,
        704,       713,       719,       725,       726,       732,
        738
};

static short styxStaFin[90] =
/* finite token per state */
{
    0,   2,   3,   2,   4,   1,   9,   0,   9,   0,
    5,   8,   6,   9,   7,  11,   0,   0,   0,   0,
    0,  15,  15,  10,  15,   7,   0,   0,   0,   0,
    0,   0,   0,   0,  15,   0,  15,   0,   0,   0,
    0,   0,  16,   0,   0,   0,   0,   0,   0,   0,
    0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
    0,   0,   0,   0,   0,   0,   0,  16,   0,  14,
    0,   0,  14,   0,   0,   0,  12,   0,   0,   0,
    0,  14,   0,   0,  13,   0,   0,  14,   0,   0
};

static wc_char styxEdgeC[738] =
/* lowest character per edge */
{ /*State*/
  /*   0 */        255,        128,        127,        126,        125,        124,
                   123,         97,         96,         94,         93,         92,
                    91,         65,         63,         60,         59,         58,
                    48,         42,         40,         39,         36,         35,
                    34,         33,         32,         27,         26,         14,
                    13,         12,         11,         10,          0,
  /*   1 */          0,
  /*   2 */          0,
  /*   3 */         11,         10,          0,
  /*   4 */        256,          0,
  /*   5 */          0,
  /*   6 */        255,        128,        127,        126,        125,        124,
                    96,         94,         65,         63,         59,         58,
                    48,         42,         39,         35,         34,         33,
                     0,
  /*   7 */        255,        128,        127,         97,         96,         93,
                    92,         40,         39,         35,         34,         32,
                     0,
  /*   8 */        255,        128,        127,        126,        125,        124,
                   118,        117,        110,        109,        106,        105,
                   102,        101,         96,         94,         65,         63,
                    59,         58,         48,         42,         39,         35,
                    34,         33,          0,
  /*   9 */        256,        255,        128,        127,         97,         96,
                    93,         92,         40,         39,         35,         34,
                    32,          0,
  /*  10 */          0,
  /*  11 */         58,         48,          0,
  /*  12 */        255,        128,        127,         32,          0,
  /*  13 */          0,
  /*  14 */        123,         97,         91,         65,         58,         48,
                     0,
  /*  15 */          0,
  /*  16 */        123,        121,        120,        117,        116,        115,
                   114,        113,        112,        111,        110,         97,
                    96,         93,         92,         91,         89,         88,
                    65,         58,         48,         40,         39,         35,
                    34,          0,
  /*  17 */        111,        110,        109,        108,          0,
  /*  18 */        111,        110,        103,        102,          0,
  /*  19 */         98,         97,          0,
  /*  20 */        111,        110,          0,
  /*  21 */         46,         45,          0,
  /*  22 */        255,        128,        127,         97,         96,         93,
                    92,         46,         45,         40,         39,         35,
                    34,         32,          0,
  /*  23 */          0,
  /*  24 */        123,        121,        120,        117,        116,        115,
                   114,        113,        112,        111,        110,         97,
                    96,         93,         92,         91,         89,         88,
                    65,         58,         48,         46,         45,         40,
                    39,         35,         34,          0,
  /*  25 */         58,         48,          0,
  /*  26 */        123,         97,         91,         65,         58,         48,
                     0,
  /*  27 */        123,         97,         91,         65,         58,         48,
                     0,
  /*  28 */        116,        115,          0,
  /*  29 */        101,        100,          0,
  /*  30 */        111,        110,        101,        100,          0,
  /*  31 */        100,         99,          0,
  /*  32 */        100,         99,          0,
  /*  33 */        101,        100,          0,
  /*  34 */          0,
  /*  35 */        255,        128,        127,         97,         96,         93,
                    92,         40,         39,         35,         34,         32,
                     0,
  /*  36 */        255,        128,        127,         97,         96,         93,
                    92,         40,         39,         35,         34,         32,
                     0,
  /*  37 */        123,        121,        120,        117,        116,        115,
                   114,        113,        112,        111,        110,         97,
                    96,         93,         92,         91,         89,         88,
                    65,         58,         48,         40,         39,         35,
                    34,          0,
  /*  38 */        123,         97,         91,         65,         58,         48,
                     0,
  /*  39 */        123,         97,         91,         65,         58,         48,
                     0,
  /*  40 */        255,        128,        127,        123,         97,         96,
                    93,         92,         91,         65,         58,         48,
                    40,         39,         35,         34,         32,          0,
  /*  41 */        102,        101,          0,
  /*  42 */          0,
  /*  43 */        102,        101,          0,
  /*  44 */        101,        100,          0,
  /*  45 */        109,        108,          0,
  /*  46 */        115,        114,          0,
  /*  47 */        102,        101,          0,
  /*  48 */        255,        128,        127,        123,         97,         96,
                    93,         92,         91,         65,         58,         48,
                    40,         39,         35,         34,         32,          0,
  /*  49 */        255,        128,        127,        123,         97,         96,
                    93,         92,         91,         65,         58,         48,
                    40,         39,         35,         34,         32,          0,
  /*  50 */        103,        102,          0,
  /*  51 */        118,        117,          0,
  /*  52 */        112,        111,          0,
  /*  53 */        103,        102,          0,
  /*  54 */        255,        128,        127,        123,         97,         96,
                    93,         92,         91,         65,         58,         48,
                    40,         39,         35,         34,         32,          0,
  /*  55 */        255,        128,        127,        123,         97,         96,
                    93,         92,         91,         65,         58,         48,
                    40,         39,         35,         34,         32,          0,
  /*  56 */         33,         32,         14,         12,         11,         10,
                     0,
  /*  57 */        101,        100,          0,
  /*  58 */         33,         32,         14,         12,         11,         10,
                     0,
  /*  59 */        106,        105,          0,
  /*  60 */        255,        128,        127,        123,         97,         96,
                    93,         92,         91,         65,         58,         48,
                    40,         39,         35,         34,         32,          0,
  /*  61 */        255,        128,        127,         97,         96,         93,
                    92,         40,         39,         35,         34,         32,
                     0,
  /*  62 */        123,         97,         96,         95,         91,         65,
                    33,         32,         14,         12,         11,         10,
                     0,
  /*  63 */        102,        101,          0,
  /*  64 */        123,         97,         96,         95,         91,         65,
                    33,         32,         14,         12,         11,         10,
                     0,
  /*  65 */        111,        110,          0,
  /*  66 */        255,        128,        127,         97,         96,         93,
                    92,         40,         39,         35,         34,         32,
                     0,
  /*  67 */        123,         97,         96,         95,         91,         65,
                    58,         48,          0,
  /*  68 */         33,         32,         14,         12,         11,         10,
                     0,
  /*  69 */        123,         97,         96,         95,         91,         65,
                    62,         61,         58,         48,         41,         40,
                    33,         32,         14,         12,         11,         10,
                     0,
  /*  70 */        102,        101,          0,
  /*  71 */        255,        128,        127,         33,         32,         14,
                    12,         11,         10,          0,
  /*  72 */         62,         61,         41,         40,         33,         32,
                    14,         12,         11,         10,          0,
  /*  73 */        255,        128,        127,         62,         61,         45,
                    44,         42,         41,         33,         32,         14,
                    12,         11,         10,          0,
  /*  74 */        256,         36,         35,          0,
  /*  75 */         33,         32,         14,         12,         11,         10,
                     0,
  /*  76 */        255,        128,        127,         33,          0,
  /*  77 */        255,        128,        127,         62,         61,         45,
                    44,         42,         41,         33,         32,         14,
                    12,         11,         10,          0,
  /*  78 */        256,        110,        109,        102,        101,         36,
                    35,          0,
  /*  79 */        123,         97,         96,         95,         91,         65,
                    33,         32,         14,         12,         11,         10,
                     0,
  /*  80 */         45,         44,         42,         41,         33,         32,
                    14,         12,         11,         10,          0,
  /*  81 */         62,         61,         33,         32,         14,         12,
                    11,         10,          0,
  /*  82 */        256,        111,        110,         36,         35,          0,
  /*  83 */        256,         98,         97,         36,         35,          0,
  /*  84 */        123,         97,         96,         95,         91,         65,
                    58,         48,          0,
  /*  85 */        256,        101,        100,         36,         35,          0,
  /*  86 */        256,        100,         99,         36,         35,          0,
  /*  87 */          0,
  /*  88 */        256,        115,        114,         36,         35,          0,
  /*  89 */        256,        112,        111,         36,         35,          0
};

static long styxEdgeS[738] =
/* follow (state+1) per edge */
{ /*State*/
  /*   0 */         0,         7,         0,         7,        11,         7,
                   11,        15,         0,         7,        11,         0,
                   11,        15,         7,        14,        13,         7,
                   12,         7,        11,        10,         7,         9,
                    8,         7,         6,         0,         5,         0,
                    4,         3,         0,         2,         0,
  /*   1 */         0,
  /*   2 */         0,
  /*   3 */         0,         2,         0,
  /*   4 */         0,         5,
  /*   5 */         0,
  /*   6 */         0,         7,         0,         7,         0,         7,
                    0,         7,         0,         7,         0,         7,
                    0,         7,         0,         7,         0,         7,
                    0,
  /*   7 */         0,         8,         0,         8,         0,         8,
                   17,         8,         0,         8,        16,         8,
                    0,
  /*   8 */         0,         7,         0,         7,         0,         7,
                    0,        21,         0,        20,         0,        19,
                    0,        18,         0,         7,         0,         7,
                    0,         7,         0,         7,         0,         7,
                    0,         7,         0,
  /*   9 */         0,        22,        23,        22,        23,        22,
                   23,        25,        23,        24,        23,        22,
                   23,        22,
  /*  10 */         0,
  /*  11 */         0,        12,         0,
  /*  12 */         0,        13,         0,        13,         0,
  /*  13 */         0,
  /*  14 */         0,        15,         0,        15,         0,        26,
                    0,
  /*  15 */         0,
  /*  16 */         0,        27,        28,        27,         8,        27,
                    8,        27,         8,        27,         8,        27,
                    8,         0,         8,         0,        27,        28,
                   27,         0,        27,         0,         8,         0,
                    8,         0,
  /*  17 */         0,        30,         0,        29,         0,
  /*  18 */         0,        32,         0,        31,         0,
  /*  19 */         0,        33,         0,
  /*  20 */         0,        34,         0,
  /*  21 */         0,        35,         0,
  /*  22 */         0,        36,         0,        36,         0,        36,
                   38,        36,        37,        36,        24,        36,
                    0,        36,         0,
  /*  23 */         0,
  /*  24 */         0,        39,        40,        39,        36,        39,
                   36,        39,        36,        39,        36,        39,
                   36,         0,        36,         0,        39,        40,
                   39,         0,        39,         0,        35,         0,
                   36,         0,        36,         0,
  /*  25 */         0,        26,         0,
  /*  26 */         0,         8,         0,         8,         0,         8,
                    0,
  /*  27 */         0,        41,         0,        41,         0,        41,
                    0,
  /*  28 */         0,        42,         0,
  /*  29 */         0,        43,         0,
  /*  30 */         0,        45,         0,        44,         0,
  /*  31 */         0,        46,         0,
  /*  32 */         0,        47,         0,
  /*  33 */         0,        48,         0,
  /*  34 */         0,
  /*  35 */         0,        36,         0,        36,         0,        36,
                   38,        36,        24,        36,         0,        36,
                    0,
  /*  36 */         0,        36,         0,        36,         0,        36,
                   38,        36,        24,        36,         0,        36,
                    0,
  /*  37 */         0,        39,        40,        39,        36,        39,
                   36,        39,        36,        39,        36,        39,
                   36,         0,        36,         0,        39,        40,
                   39,         0,        39,         0,        36,         0,
                   36,         0,
  /*  38 */         0,        36,         0,        36,         0,        36,
                    0,
  /*  39 */         0,        49,         0,        49,         0,        49,
                    0,
  /*  40 */         0,         8,         0,         8,        50,         0,
                    8,        17,         8,        50,         8,        50,
                    8,         0,         8,        16,         8,         0,
  /*  41 */         0,        43,         0,
  /*  42 */         0,
  /*  43 */         0,        51,         0,
  /*  44 */         0,        44,         0,
  /*  45 */         0,        52,         0,
  /*  46 */         0,        53,         0,
  /*  47 */         0,        54,         0,
  /*  48 */         0,        36,         0,        36,        55,         0,
                   36,        38,        36,        55,        36,        55,
                   36,        24,        36,         0,        36,         0,
  /*  49 */         0,         8,         0,         8,        56,         0,
                    8,        17,         8,        56,         8,        56,
                    8,         0,         8,        16,         8,         0,
  /*  50 */         0,        57,         0,
  /*  51 */         0,        58,         0,
  /*  52 */         0,        59,         0,
  /*  53 */         0,        60,         0,
  /*  54 */         0,        36,         0,        36,        61,         0,
                   36,        38,        36,        61,        36,        61,
                   36,        24,        36,         0,        36,         0,
  /*  55 */         0,         8,         0,         8,        62,         0,
                    8,        17,         8,        62,         8,        62,
                    8,         0,         8,        16,         8,         0,
  /*  56 */         0,        63,         0,        63,         0,        63,
                    0,
  /*  57 */         0,        64,         0,
  /*  58 */         0,        65,         0,        65,         0,        65,
                    0,
  /*  59 */         0,        66,         0,
  /*  60 */         0,        36,         0,        36,        67,         0,
                   36,        38,        36,        67,        36,        67,
                   36,        24,        36,         0,        36,         0,
  /*  61 */         0,         8,         0,         8,         0,         8,
                   17,         8,         0,         8,        16,         8,
                    0,
  /*  62 */         0,        68,         0,        68,         0,        68,
                    0,        63,         0,        63,         0,        63,
                    0,
  /*  63 */         0,        69,         0,
  /*  64 */         0,        70,         0,        70,         0,        70,
                    0,        65,         0,        65,         0,        65,
                    0,
  /*  65 */         0,        71,         0,
  /*  66 */         0,        36,         0,        36,         0,        36,
                   38,        36,        24,        36,         0,        36,
                    0,
  /*  67 */         0,        68,         0,        68,         0,        68,
                    0,        68,         0,
  /*  68 */         0,        72,         0,        72,         0,        72,
                    0,
  /*  69 */         0,        70,         0,        70,         0,        70,
                    0,        75,         0,        70,         0,        74,
                    0,        73,         0,        73,         0,        73,
                    0,
  /*  70 */         0,        76,         0,
  /*  71 */         0,        77,         0,        77,        72,         0,
                   72,         0,        72,         0,
  /*  72 */         0,        75,         0,        74,         0,        73,
                    0,        73,         0,        73,         0,
  /*  73 */         0,        78,         0,        78,         0,        78,
                    0,        78,         0,        78,        74,         0,
                   74,         0,        74,         0,
  /*  74 */         0,        75,        79,        75,
  /*  75 */         0,        80,         0,        80,         0,        80,
                    0,
  /*  76 */         0,        77,         0,        77,         0,
  /*  77 */         0,        78,         0,        78,         0,        78,
                   74,        78,        82,        78,        81,         0,
                   81,         0,        81,         0,
  /*  78 */         0,        75,        84,        75,        83,        75,
                   79,        75,
  /*  79 */         0,        85,         0,        85,         0,        85,
                    0,        80,         0,        80,         0,        80,
                    0,
  /*  80 */         0,        74,         0,        82,         0,        81,
                    0,        81,         0,        81,         0,
  /*  81 */         0,        75,         0,        82,         0,        82,
                    0,        82,         0,
  /*  82 */         0,        75,        86,        75,        79,        75,
  /*  83 */         0,        75,        87,        75,        79,        75,
  /*  84 */         0,        85,         0,        85,         0,        85,
                    0,        85,         0,
  /*  85 */         0,        75,        88,        75,        79,        75,
  /*  86 */         0,        75,        89,        75,        79,        75,
  /*  87 */         0,
  /*  88 */         0,        75,        90,        75,        79,        75,
  /*  89 */         0,        75,         0,        75,        79,        75
};

static string styxTokens[17] =
/* token -> string */
{
  "[other]",
  "Space",
  "Line",
  "Page",
  "Etx",
  "Parenthesis",
  "Comment",
  "Ide",
  "Nat",
  "Opr",
  "Set",
  "Seq",
  "MacInc",
  "MacDel",
  "MacDfn",
  "MacSep",
  "MacCond"
};

static byte styxFlags[17] =
/* token -> newid */
{
  0x00, 0x01, 0x01, 0x01, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

static ConcreteImp(scn_t) styxScanner =
/* the scanner structure */
{
  "styx", /* Name    */
  90,     /* States  */
  17,     /* Tokens  */
  styxStaEdg,
  styxStaFin,
  styxEdgeC,
  styxEdgeS,
  styxTokens,
  styxFlags,
   0,     /* Groups  */
  (scn_t*)NULL,
  (short*)NULL,
  0, /* Dyck */
  (short*)NULL,
  (scn_t*)NULL
};


void Scn_get_styx(Scn_T *scn)
/* simulates a Scn_get */
{
  *scn = Scn_copy(Scn_ADT(&styxScanner));
}
