/* [styx_pim.c] Parser table for 'styx'  */



#include "prs.h"

#include "prs_imp.h"


static string styx_SNames[] = {
  "Parenthesis", "Comment", "Ide", "Nat", "Opr", 
  "Set", "Seq", "MacInc", "MacDel", "MacDfn", 
  "MacSep", "MacCond", "Language", "Context", "Free", 
  "Grammar", "Regular", "=", "tok", "<", 
  ">", "InGroup", "ExGroup", "[", "]", 
  "Group", "let", "ign", "com", "lan", 
  "ind", ":", "!", "!+", "!-", 
  "ica", "/", "?", "|", "-", 
  ",", "{", "}", "*", "+", 
  "..", "(", ")", "xtop", "start", 
  "err", "other", "...", ".", "reduce", 
  "Source", "OptCfg", "QlxDfns0", "QlxDfns", "QlxDfn", 
  "Ids0", "Ids", "QlxCat", "QlxGrp", "QlxGrp0", 
  "QlxGrp1", "QlxOpt", "ExpQuot", "ExpDyck", "Exp0", 
  "Exp", "Exp1", "OptNat", "Limit", "Exp2", 
  "Exp3", "Exp4", "Dfns", "Dfn", "Cat0", 
  "Cat", "DfnOpt", "Prds", "Lay", "Prd", 
  "Mbrs", "Mbr", "Mbr1", "OptKey", "Conflicts", 
  "Conflict", "State", "Token", "Rules0", "Rules", 
  "Rule"
};

static int styx_StartIds[] = {
  55
};

static int styx_TokKind[] = {
  1, 6, 1, 1, 1, 1, 1, 1, 
  1, 1, 1, 1, 2, 2, 2, 2, 
  2, 2, 2, 2, 2, 2, 2, 2, 
  2, 2, 2, 2, 2, 2, 2, 2, 
  2, 2, 2, 2, 2, 2, 2, 2, 
  2, 2, 2, 2, 2, 2, 2, 2, 
  2, 2, 2, 2, 2, 2, 2
};

static int styx_NtClass[] = {
  0, 1, 3, 3, 4, 6, 6, 7, 
  8, 8, 8, 11, 15, 15, 15, 15, 
  15, 17, 18, 15, 15, 15, 22, 23, 
  25, 25, 26, 27, 28, 29, 30, 31, 
  31, 33, 34, 35, 36, 37, 39, 39, 
  40
};

static c_bool styx_ErrorNt[] = {
  0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 
  0
};

static KFGHEAD styx_KfgHead = {
  "styx",
  55, 41, styx_SNames,
  1, styx_StartIds,
  styx_TokKind,
  styx_NtClass,
  styx_ErrorNt
};

static int styx_PSymbols[] = {
  12, 72, 2, 57, 56,
  13, 14, 15, 77, 89,
  16, 15, 58,
  59, 58,
  62, 66, 64, 2, 65, 17, 67,
  18, 19, 2, 20,
  21, 2,
  22, 2,
  22, 2, 23, 18, 24,
  25, 2, 17, 61,
  2, 60,
  2, 60,
  26,
  18,
  27,
  28,
  29,
  30,
  31, 2, 31,
  63,
  32, 2,
  32,
  33, 2,
  33,
  34,
  63,
  23, 35, 24,
  68, 36, 76,
  68,
  19, 70, 20, 69, 19, 70, 20,
  19, 17, 69, 20, 5, 19, 69, 20,
  19, 37, 69, 20, 2, 19, 69, 20,
  70,
  70,
  70, 38, 71,
  70, 39, 71,
  71,
  71, 74,
  74,
  3,
  3,
  3, 40, 72,
  23, 70, 24,
  41, 70, 42,
  75, 43,
  75, 44,
  75, 73,
  75,
  76,
  76, 45, 76,
  46, 70, 47,
  6,
  5,
  2,
  78, 77,
  80, 81, 2, 82,
  48,
  26,
  49,
  79,
  23, 50, 24,
  84, 82,
  31,
  37,
  32,
  83, 2, 31, 85,
  86, 85,
  6,
  23, 51, 24,
  87,
  2,
  23, 88, 87, 88, 52, 88, 24,
  46, 88, 87, 88, 52, 88, 47,
  23, 88, 87, 88, 24,
  2, 19, 2, 20,
  6, 88,
  90, 89,
  13, 91, 53, 92, 31, 94,
  3,
  6,
  2,
  6,
  2,
  95, 93,
  95, 93,
  54, 2, 53, 2,
  55
};

static int styx_PSymFrms[] = {
  0, 11, 18, 0, 0,
  0, 10, 17, -2, -2,
  0, 10, -2,
  0, 0,
  0, 7, 14, 22, 26, 34, 38,
  0, 6, 10, 14,
  0, 10,
  0, 10,
  0, 10, 14, 18, 24,
  0, 10, 14, 18,
  0, 4,
  0, 4,
  0,
  0,
  0,
  0,
  0,
  0,
  0, 4, 8,
  0,
  0, 5,
  0,
  0, 5,
  0,
  0,
  0,
  0, 4, 10,
  0, 8, 12,
  0,
  0, 4, 8, 12, 17, 21, 25,
  0, 4, 8, 13, 17, 21, 25, 30,
  0, 4, 8, 13, 17, 21, 25, 30,
  0,
  0,
  0, 4, 8,
  0, 4, 8,
  0,
  0, 5,
  0,
  0,
  0,
  0, 4, 8,
  0, 4, 8,
  0, 4, 8,
  0, 5,
  0, 5,
  0, 5,
  0,
  0,
  0, 5, 10,
  0, 4, 8,
  0,
  0,
  0,
  0, 0,
  0, 4, 11, 0,
  0,
  0,
  0,
  0,
  0, 4, 10,
  0, 0,
  0,
  0,
  0,
  0, 4, 8, -2,
  0, 0,
  0,
  0, 4, 12,
  0,
  0,
  0, 4, 11, 16, 23, 29, 36,
  0, 4, 11, 16, 23, 29, 36,
  0, 4, 11, 16, 23,
  0, 4, 8, 12,
  0, 4,
  0, 0,
  0, 10, 16, 20, 26, 0,
  0,
  0,
  0,
  0,
  0,
  0, 0,
  0, 0,
  0, 9, 13, 17,
  0
};

static KFGPROD styx_KfgProds[] = {
  { "root", 0, 55, 5, &styx_PSymbols[0], &styx_PSymFrms[0], -1, -1 },
  { "non", 0, 56, 0, (int*)NULL, (int*)NULL, -1, -1 },
  { "cfg", 0, 56, 5, &styx_PSymbols[5], &styx_PSymFrms[5], -1, -1 },
  { "nil", 0, 57, 0, (int*)NULL, (int*)NULL, -1, -1 },
  { "ign0", 0, 57, 3, &styx_PSymbols[10], &styx_PSymFrms[10], -1, -1 },
  { "nil", 0, 58, 0, (int*)NULL, (int*)NULL, -1, -1 },
  { "cons", 0, 58, 2, &styx_PSymbols[13], &styx_PSymFrms[13], -1, -1 },
  { "defn", 2, 59, 7, &styx_PSymbols[15], &styx_PSymFrms[15], -1, -1 },
  { "defd", 2, 59, 4, &styx_PSymbols[22], &styx_PSymFrms[22], -1, -1 },
  { "igrp", 2, 59, 2, &styx_PSymbols[26], &styx_PSymFrms[26], -1, -1 },
  { "xgrp", 2, 59, 2, &styx_PSymbols[28], &styx_PSymFrms[28], -1, -1 },
  { "tgrp", 2, 59, 5, &styx_PSymbols[30], &styx_PSymFrms[30], -1, -1 },
  { "mgrp", 2, 59, 4, &styx_PSymbols[35], &styx_PSymFrms[35], -1, -1 },
  { "nil", 0, 60, 0, (int*)NULL, (int*)NULL, -1, -1 },
  { "cons", 0, 60, 2, &styx_PSymbols[39], &styx_PSymFrms[39], -1, -1 },
  { "cons", 0, 61, 2, &styx_PSymbols[41], &styx_PSymFrms[41], -1, -1 },
  { "letC", 0, 62, 1, &styx_PSymbols[43], &styx_PSymFrms[43], -1, -1 },
  { "tokC", 0, 62, 1, &styx_PSymbols[44], &styx_PSymFrms[44], -1, -1 },
  { "ignC", 0, 62, 1, &styx_PSymbols[45], &styx_PSymFrms[45], -1, -1 },
  { "comC", 0, 62, 1, &styx_PSymbols[46], &styx_PSymFrms[46], -1, -1 },
  { "lanC", 0, 62, 1, &styx_PSymbols[47], &styx_PSymFrms[47], -1, -1 },
  { "indC", 0, 62, 1, &styx_PSymbols[48], &styx_PSymFrms[48], -1, -1 },
  { "non", 0, 63, 0, (int*)NULL, (int*)NULL, -1, -1 },
  { "grp", 0, 64, 3, &styx_PSymbols[49], &styx_PSymFrms[49], -1, -1 },
  { "ign0", 0, 64, 1, &styx_PSymbols[52], &styx_PSymFrms[52], -1, -1 },
  { "grp", 0, 65, 2, &styx_PSymbols[53], &styx_PSymFrms[53], -1, -1 },
  { "igrp", 0, 65, 1, &styx_PSymbols[55], &styx_PSymFrms[55], -1, -1 },
  { "pgrp", 0, 65, 2, &styx_PSymbols[56], &styx_PSymFrms[56], -1, -1 },
  { "pigrp", 0, 65, 1, &styx_PSymbols[58], &styx_PSymFrms[58], -1, -1 },
  { "pop", 0, 65, 1, &styx_PSymbols[59], &styx_PSymFrms[59], -1, -1 },
  { "ign0", 0, 65, 1, &styx_PSymbols[60], &styx_PSymFrms[60], -1, -1 },
  { "non", 0, 66, 0, (int*)NULL, (int*)NULL, -1, -1 },
  { "ignca", 0, 66, 3, &styx_PSymbols[61], &styx_PSymFrms[61], -1, -1 },
  { "quot", 0, 67, 3, &styx_PSymbols[64], &styx_PSymFrms[64], -1, -1 },
  { "ign0", 0, 67, 1, &styx_PSymbols[67], &styx_PSymFrms[67], -1, -1 },
  { "dyck", 0, 68, 7, &styx_PSymbols[68], &styx_PSymFrms[68], -1, -1 },
  { "spat", 0, 68, 8, &styx_PSymbols[75], &styx_PSymFrms[75], -1, -1 },
  { "epat", 0, 68, 8, &styx_PSymbols[83], &styx_PSymFrms[83], -1, -1 },
  { "ign0", 0, 68, 1, &styx_PSymbols[91], &styx_PSymFrms[91], -1, -1 },
  { "non", 0, 69, 0, (int*)NULL, (int*)NULL, -1, -1 },
  { "ign0", 0, 69, 1, &styx_PSymbols[92], &styx_PSymFrms[92], -1, -1 },
  { "union", 0, 70, 3, &styx_PSymbols[93], &styx_PSymFrms[93], -1, -1 },
  { "diff", 0, 70, 3, &styx_PSymbols[96], &styx_PSymFrms[96], -1, -1 },
  { "ign1", 0, 70, 1, &styx_PSymbols[99], &styx_PSymFrms[99], -1, -1 },
  { "conc", 0, 71, 2, &styx_PSymbols[100], &styx_PSymFrms[100], -1, -1 },
  { "ign1", 0, 71, 1, &styx_PSymbols[102], &styx_PSymFrms[102], -1, -1 },
  { "non", 0, 72, 0, (int*)NULL, (int*)NULL, -1, -1 },
  { "nat", 0, 72, 1, &styx_PSymbols[103], &styx_PSymFrms[103], -1, -1 },
  { "ntime", 0, 73, 1, &styx_PSymbols[104], &styx_PSymFrms[104], -1, -1 },
  { "range", 0, 73, 3, &styx_PSymbols[105], &styx_PSymFrms[105], -1, -1 },
  { "opt", 0, 74, 3, &styx_PSymbols[108], &styx_PSymFrms[108], -1, -1 },
  { "star", 0, 74, 3, &styx_PSymbols[111], &styx_PSymFrms[111], -1, -1 },
  { "plus0", 0, 74, 2, &styx_PSymbols[114], &styx_PSymFrms[114], -1, -1 },
  { "plus", 0, 74, 2, &styx_PSymbols[116], &styx_PSymFrms[116], -1, -1 },
  { "plusn", 0, 74, 2, &styx_PSymbols[118], &styx_PSymFrms[118], -1, -1 },
  { "ign1", 0, 74, 1, &styx_PSymbols[120], &styx_PSymFrms[120], -1, -1 },
  { "ign1", 0, 75, 1, &styx_PSymbols[121], &styx_PSymFrms[121], -1, -1 },
  { "range", 0, 75, 3, &styx_PSymbols[122], &styx_PSymFrms[122], -1, -1 },
  { "ign2", 0, 75, 3, &styx_PSymbols[125], &styx_PSymFrms[125], -1, -1 },
  { "sequ", 0, 76, 1, &styx_PSymbols[128], &styx_PSymFrms[128], -1, -1 },
  { "set", 0, 76, 1, &styx_PSymbols[129], &styx_PSymFrms[129], -1, -1 },
  { "ident", 0, 76, 1, &styx_PSymbols[130], &styx_PSymFrms[130], -1, -1 },
  { "nil", 0, 77, 0, (int*)NULL, (int*)NULL, -1, -1 },
  { "cons", 0, 77, 2, &styx_PSymbols[131], &styx_PSymFrms[131], -1, -1 },
  { "defn", 2, 78, 4, &styx_PSymbols[133], &styx_PSymFrms[133], -1, -1 },
  { "bgnC", 0, 79, 1, &styx_PSymbols[137], &styx_PSymFrms[137], -1, -1 },
  { "letC", 0, 80, 1, &styx_PSymbols[138], &styx_PSymFrms[138], -1, -1 },
  { "bgnC", 0, 80, 1, &styx_PSymbols[139], &styx_PSymFrms[139], -1, -1 },
  { "ign0", 0, 80, 1, &styx_PSymbols[140], &styx_PSymFrms[140], -1, -1 },
  { "non", 0, 81, 0, (int*)NULL, (int*)NULL, -1, -1 },
  { "errnt", 0, 81, 3, &styx_PSymbols[141], &styx_PSymFrms[141], -1, -1 },
  { "nil", 0, 82, 0, (int*)NULL, (int*)NULL, -1, -1 },
  { "cons", 0, 82, 2, &styx_PSymbols[144], &styx_PSymFrms[144], -1, -1 },
  { "dft", 0, 83, 1, &styx_PSymbols[146], &styx_PSymFrms[146], -1, -1 },
  { "rec", 0, 83, 1, &styx_PSymbols[147], &styx_PSymFrms[147], -1, -1 },
  { "grp", 0, 83, 1, &styx_PSymbols[148], &styx_PSymFrms[148], -1, -1 },
  { "prod", 1, 84, 4, &styx_PSymbols[149], &styx_PSymFrms[149], -1, -1 },
  { "nil", 0, 85, 0, (int*)NULL, (int*)NULL, -1, -1 },
  { "cons", 1, 85, 2, &styx_PSymbols[153], &styx_PSymFrms[153], -1, -1 },
  { "tkm", 0, 86, 1, &styx_PSymbols[155], &styx_PSymFrms[155], -1, -1 },
  { "else", 0, 86, 3, &styx_PSymbols[156], &styx_PSymFrms[156], -1, -1 },
  { "ign0", 0, 86, 1, &styx_PSymbols[159], &styx_PSymFrms[159], -1, -1 },
  { "ntm", 0, 87, 1, &styx_PSymbols[160], &styx_PSymFrms[160], -1, -1 },
  { "klst0", 0, 87, 7, &styx_PSymbols[161], &styx_PSymFrms[161], -1, -1 },
  { "klst1", 0, 87, 7, &styx_PSymbols[168], &styx_PSymFrms[168], -1, -1 },
  { "opt", 0, 87, 5, &styx_PSymbols[175], &styx_PSymFrms[175], -1, -1 },
  { "dtok", 0, 87, 4, &styx_PSymbols[180], &styx_PSymFrms[180], -1, -1 },
  { "nil", 0, 88, 0, (int*)NULL, (int*)NULL, -1, -1 },
  { "cons", 0, 88, 2, &styx_PSymbols[184], &styx_PSymFrms[184], -1, -1 },
  { "nil", 0, 89, 0, (int*)NULL, (int*)NULL, -1, -1 },
  { "cons", 0, 89, 2, &styx_PSymbols[186], &styx_PSymFrms[186], -1, -1 },
  { "defn", 2, 90, 6, &styx_PSymbols[188], &styx_PSymFrms[188], -1, -1 },
  { "nat", 0, 91, 1, &styx_PSymbols[194], &styx_PSymFrms[194], -1, -1 },
  { "seq", 0, 91, 1, &styx_PSymbols[195], &styx_PSymFrms[195], -1, -1 },
  { "ide", 0, 91, 1, &styx_PSymbols[196], &styx_PSymFrms[196], -1, -1 },
  { "seq", 0, 92, 1, &styx_PSymbols[197], &styx_PSymFrms[197], -1, -1 },
  { "ide", 0, 92, 1, &styx_PSymbols[198], &styx_PSymFrms[198], -1, -1 },
  { "nil", 0, 93, 0, (int*)NULL, (int*)NULL, -1, -1 },
  { "cons", 0, 93, 2, &styx_PSymbols[199], &styx_PSymFrms[199], -1, -1 },
  { "cons", 0, 94, 2, &styx_PSymbols[201], &styx_PSymFrms[201], -1, -1 },
  { "red", 0, 95, 4, &styx_PSymbols[203], &styx_PSymFrms[203], -1, -1 },
  { "Start_Source", 0, 96, 1, &styx_PSymbols[207], &styx_PSymFrms[207], -1, -1 }
};

static int styx_MstShifts[] = {
  1, 3, -1, -1, 5, 7, 9, 11, 
  21, 31, -1, 33, 35, 37, 39, -1, 
  -1, -1, -1, -1, -1, 21, 41, 43, 
  45, -1, 47, 49, -1, 51, 53, 57, 
  61, 63, 65, 67, 69, -1, 71, -1, 
  -1, -1, 73, 57, -1, 75, -1, 77, 
  79, -1, -1, 81, 85, 91, -1, 73, 
  -1, 95, 97, -1, 79, -1, -1, 99, 
  101, -1, -1, 103, -1, -1, -1, 105, 
  -1, 107, 111, -1, -1, -1, 121, 130, 
  -1, -1, -1, -1, -1, 133, 111, -1, 
  -1, -1, 142, 156, 156, 156, -1, 163, 
  166, 156, -1, 171, 175, -1, -1, 177, 
  179, -1, 156, 156, 183, 189, 195, 201, 
  207, 156, 156, -1, 211, -1, -1, -1, 
  207, 213, 218, 223, 166, 225, 156, -1, 
  -1, -1, -1, 156, 156, 3, -1, 227, 
  -1, 213, 229, -1, 232, 235, -1, 218, 
  -1, 237, 239, 241, -1, 243, -1, 213, 
  245, 235, 247, 251, 251, -1, 255, 257, 
  156, 259, -1, 261, -1, -1, 235, 235, 
  235, 156, 156, 265, -1, -1, 270, 273, 
  275, 277, -1, -1, 235, 235, -1, -1, 
  279, 281, -1, -1
};

static int styx_DtlShifts[] = {
  -2, 12, -4, 3, -6, 2, -7, 16, 
  -9, 15, -10, 13, -12, -13, -14, -15, 
  -16, -17, -18, -19, -20, 30, 29, 28, 
  27, 26, 25, 22, 21, 18, -24, 14, 
  -25, 19, -26, 2, -27, 2, -28, 2, 
  -30, 23, -32, 15, -33, 2, -34, 23, 
  -35, 17, -36, 35, -37, 31, -40, -41, 
  -42, 49, 48, 26, -47, 20, -48, 18, 
  -49, 2, -51, 24, -52, 2, -53, 2, 
  -54, 13, -58, 23, -60, 24, -61, 2, 
  -63, 31, -64, -65, -66, 34, 33, 32, 
  -69, -70, -71, 6, 3, 2, -74, 50, 
  -75, 2, -77, 2, -78, 2, -79, 17, 
  -80, 53, -81, 24, -82, -83, -84, 37, 
  32, 31, -88, -89, -90, -91, -92, -93, 
  -94, 46, 41, 23, 19, 6, 5, 2, 
  -102, -103, 6, 2, -105, 2, -88, -89, 
  -90, -92, -93, -94, -107, -108, 37, 17, 
  46, 41, 23, 6, 5, 2, -88, -89, 
  -90, -92, -93, -94, 46, 41, 23, 6, 
  5, 2, -113, 36, -114, -115, 39, 38, 
  -117, -118, -119, 44, 43, 3, -121, 45, 
  -122, 31, -123, 31, -114, -115, -127, 20, 
  39, 38, -114, -115, -128, 24, 39, 38, 
  -114, -115, -129, 42, 39, 38, -114, -115, 
  -130, 47, 39, 38, -88, -89, -90, 6, 
  5, 2, -134, 40, -136, 54, -139, -140, 
  -141, -142, 46, 23, 6, 2, -146, 20, 
  -147, 20, -150, 2, -153, 19, -154, -155, 
  51, 6, -154, 6, -159, 5, -160, 2, 
  -161, 19, -162, 53, -164, 2, -166, 24, 
  -139, -142, -167, 23, 46, 2, -170, 19, 
  -171, 19, -173, 2, -174, 20, -114, -115, 
  -179, 20, 39, 38, -180, -181, 52, 24, 
  -182, 52, -183, 20, -184, 20, -187, 24, 
  -188, 47
};

static int styx_GoTos[] = {
  0, 2, 4, 6, 10, 13, 17, 19, 
  22, 26, 28, 30, 32, 34, 36, 46, 
  64, 80, 84, 86, 104, 121, 142, 146, 
  149, 152, 155, 157, 161, 164, 167, 171, 
  174, 181, 196, 200, 203, 205, 207, 211, 
  213
};

static int styx_GoToDfts[] = {
  191, -1, 199, -8, 196, -6, 209, 9, 
  217, 22, 210, -9, -22, 250, 49, 264, 
  61, 238, -35, 211, -9, -22, 226, 31, 
  255, 53, 227, -31, 256, -53, 219, -23, 
  283, -79, 284, -79, 312, 107, 314, 108, 
  336, 127, 365, 170, 366, 171, 285, 79, 
  297, 91, 298, 92, 299, 93, 300, 94, 
  313, 107, 108, 127, 170, 171, 360, 161, 
  286, 79, 91, 92, 93, 94, 107, 108, 
  127, 161, 170, 171, 320, 114, 321, 115, 
  193, 2, 337, 134, 308, -100, 287, 79, 
  91, 92, 93, 94, 107, 108, 114, 115, 
  127, 161, 170, 171, 304, 98, 132, 133, 
  288, -79, -91, -92, -93, -94, -98, -107, 
  -108, -114, -115, -127, -132, -133, -161, -170, 
  -171, 289, 79, 91, 92, 93, 94, 98, 
  107, 108, 114, 115, 127, 132, 133, 161, 
  170, 171, 319, 113, 323, 121, 231, 32, 
  245, 44, 232, -32, -44, 233, -32, -44, 
  234, -32, -44, 247, -46, 273, 75, 294, 
  87, 274, -75, -87, 275, -75, -87, 331, 
  123, 346, 144, 332, -123, -144, 333, 123, 
  144, 356, 156, 357, 157, 344, 141, 167, 
  345, 142, 353, 154, 363, 168, 364, 169, 
  373, 181, 374, 182, 243, 43, 261, 56, 
  244, -43, -56, 260, -54, 292, -80, 339, 
  138, 351, 152, 325, -122, 326, 122, 340, 
  138, 152
};

static int styx_ActDfts[] = {
  103, 47, 104, 48, 103, 4, 103, 2, 
  6, 103, 1, 18, 103, 103, 103, 17, 
  19, 20, 21, 22, 5, 6, 32, 103, 
  103, 10, 11, 103, 7, 103, 23, 63, 
  103, 103, 103, 103, 103, 25, 103, 67, 
  66, 68, 90, 63, 69, 70, 9, 103, 
  14, 13, 33, 103, 23, 103, 3, 90, 
  64, 103, 103, 12, 14, 16, 24, 27, 
  29, 30, 31, 103, 95, 93, 94, 103, 
  91, 103, 72, 15, 26, 28, 103, 103, 
  71, 74, 76, 75, 65, 103, 72, 62, 
  61, 60, 103, 103, 103, 103, 8, 35, 
  39, 44, 46, 56, 57, 97, 96, 103, 
  103, 73, 40, 40, 103, 103, 103, 103, 
  103, 103, 103, 45, 49, 53, 54, 55, 
  103, 103, 78, 103, 41, 103, 40, 51, 
  52, 59, 34, 42, 43, 47, 58, 103, 
  92, 98, 83, 80, 88, 88, 77, 78, 
  82, 103, 103, 103, 50, 103, 100, 98, 
  103, 88, 103, 103, 103, 79, 103, 103, 
  103, 103, 99, 103, 89, 81, 88, 88, 
  88, 40, 40, 103, 101, 87, 103, 103, 
  103, 103, 36, 86, 88, 88, 37, 38, 
  103, 103, 84, 85
};


static PARSETAB styx_ParseTab = {
  &styx_KfgHead, 102, styx_KfgProds,
  {
    188, styx_MstShifts, 282, styx_DtlShifts,
    41, styx_GoTos, 218, styx_GoToDfts,
    188, styx_ActDfts, 0, (int*)NULL
  }
};

PLR_Tab PLR_get_styx()
/* simulates a PLR_getTab */
{
  return( PLR_copyTab(&styx_ParseTab) );
}
