/* [dtd_pim.c] Parser table for 'dtd'  */



#include "prs.h"

#include "prs_imp.h"


static string dtd_SNames[] = {
  "DCharRef", "HCharRef", "ERef", "PERef", "Nmtoken", 
  "XMLDecl", "PI", "CDSect", "ElmStart", "TagEnd", 
  "XMLOpr", "Keyset", "Name", "Literal", "DTDStart", 
  "IgnSect", "Comment", ">", "system", "public", 
  "[", "]", "<!", "element", "entity", 
  "attlist", "notation", "<![", "include", "]]>", 
  "cdata", "id", "idref", "idrefs", "entities", 
  "nmtoken", "nmtokens", "(", ")", "#", 
  "required", "implied", "fixed", "%", "empty", 
  "any", ")*", "|", "pcdata", ",", 
  "?", "*", "+", "ndata", "Root", 
  "Embed", "Extern", "XDecl", "ExtID0", "ExtID3", 
  "ExtID1", "ExtID", "ExtID2", "XLiteral0", "XLiteral", 
  "Decls", "Decls0", "Decls1", "Decl", "Decl1", 
  "Cond", "Attributes", "Attribute", "AType0", "AType", 
  "ADefault", "Fixed", "Entity", "EntityVal", "NData", 
  "Content", "Mixed", "XNames0", "XNames2", "XNames1", 
  "XNames", "XName0", "RExp", "RExp0", "RExp1", 
  "ROpr1", "ROpr0", "ROpr", "XName2", "XName", 
  "XName1", "XName3", "XName4"
};

static int dtd_StartIds[] = {
  54, 55
};

static int dtd_TokKind[] = {
  1, 1, 1, 1, 1, 1, 1, 1, 
  1, 1, 1, 1, 1, 1, 1, 1, 
  6, 2, 2, 2, 2, 2, 2, 2, 
  2, 2, 2, 2, 2, 2, 2, 2, 
  2, 2, 2, 2, 2, 2, 2, 2, 
  2, 2, 2, 2, 2, 2, 2, 2, 
  2, 2, 2, 2, 2, 2
};

static int dtd_NtClass[] = {
  0, 1, 2, 3, 7, 7, 7, 7, 
  7, 10, 10, 11, 11, 13, 14, 14, 
  16, 17, 18, 20, 20, 21, 22, 23, 
  24, 25, 26, 27, 27, 27, 27, 27, 
  40, 26, 26, 26, 38, 38, 38, 40, 
  40, 40, 40, 40
};

static c_bool dtd_ErrorNt[] = {
  0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0
};

static KFGHEAD dtd_KfgHead = {
  "dtd",
  54, 44, dtd_SNames,
  2, dtd_StartIds,
  dtd_TokKind,
  dtd_NtClass,
  dtd_ErrorNt
};

static int dtd_PSymbols[] = {
  14, 55,
  56,
  94, 58, 65, 17,
  57, 67,
  5,
  61,
  3,
  18, 64,
  19, 64, 63,
  60,
  59,
  19, 64, 64,
  60,
  64,
  3,
  13,
  20, 66, 21,
  68, 66,
  69, 67,
  3,
  6,
  22, 23, 94, 80, 17,
  22, 24, 77, 17,
  22, 25, 94, 71, 17,
  22, 26, 94, 61, 17,
  70,
  68,
  15,
  27, 28, 20, 56, 29,
  27, 3, 20, 56, 29,
  72, 71,
  95,
  74,
  75,
  30,
  31,
  32,
  33,
  24,
  34,
  35,
  36,
  26,
  37, 83, 38,
  73,
  39, 40,
  39, 41,
  76, 13,
  39, 42,
  43, 94, 78,
  94, 78,
  64,
  62, 79,
  97, 94,
  3,
  44,
  45,
  81,
  87,
  37, 84, 38,
  37, 86, 85, 46,
  94, 85,
  86, 82,
  47, 94, 85,
  39, 48,
  37, 88, 90,
  89, 47, 88,
  89, 49, 88,
  89,
  94, 91,
  87,
  46,
  38, 91,
  92,
  50,
  51,
  52,
  25,
  23,
  28,
  40,
  42,
  41,
  19,
  18,
  44,
  45,
  48,
  73,
  95,
  12,
  4,
  11,
  93,
  97,
  3,
  96,
  53,
  54,
  55
};

static int dtd_PSymFrms[] = {
  0, 9,
  0,
  0, 6, 13, 19,
  0, 6,
  0,
  0,
  0,
  0, 9,
  0, 9, 18,
  0,
  0,
  0, 9, 18,
  0,
  0,
  0,
  0,
  0, 4, 11,
  0, 5,
  0, 6,
  0,
  0,
  0, 5, 15, 21, 29,
  0, 5, 14, 21,
  0, 5, 15, 21, 32,
  0, 5, 16, 22, 28,
  0,
  0,
  0,
  0, 6, 16, 20, 27,
  0, 6, 12, 16, 23,
  0, 10,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0, 4, 12,
  0,
  0, 4,
  0, 4,
  0, 6,
  0, 4,
  0, 4, 10,
  0, 6,
  0,
  0, 7,
  0, 7,
  0,
  0,
  0,
  0,
  0,
  0, 4, 12,
  0, 4, 11, 18,
  0, 6,
  0, 7,
  0, 4, 10,
  0, 4,
  0, 4, 10,
  0, 6, 10,
  0, 6, 10,
  0,
  0, 6,
  0,
  0,
  0, 4,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0
};

static KFGPROD dtd_KfgProds[] = {
  { "tdoc", 0, 54, 2, &dtd_PSymbols[0], &dtd_PSymFrms[0], -1, -1 },
  { "text", 0, 54, 1, &dtd_PSymbols[2], &dtd_PSymFrms[2], -1, -1 },
  { "dfn", 0, 55, 4, &dtd_PSymbols[3], &dtd_PSymFrms[3], -1, -1 },
  { "dfn", 0, 56, 2, &dtd_PSymbols[7], &dtd_PSymFrms[7], -1, -1 },
  { "nul", 0, 57, 0, (int*)NULL, (int*)NULL, -1, -1 },
  { "dfn", 0, 57, 1, &dtd_PSymbols[9], &dtd_PSymFrms[9], -1, -1 },
  { "nul", 0, 58, 0, (int*)NULL, (int*)NULL, -1, -1 },
  { "ign0", 0, 58, 1, &dtd_PSymbols[10], &dtd_PSymFrms[10], -1, -1 },
  { "pref", 0, 59, 1, &dtd_PSymbols[11], &dtd_PSymFrms[11], -1, -1 },
  { "sys", 0, 60, 2, &dtd_PSymbols[12], &dtd_PSymFrms[12], -1, -1 },
  { "pub", 0, 61, 3, &dtd_PSymbols[14], &dtd_PSymFrms[14], -1, -1 },
  { "ign0", 0, 61, 1, &dtd_PSymbols[17], &dtd_PSymFrms[17], -1, -1 },
  { "ign1", 0, 61, 1, &dtd_PSymbols[18], &dtd_PSymFrms[18], -1, -1 },
  { "pub", 0, 62, 3, &dtd_PSymbols[19], &dtd_PSymFrms[19], -1, -1 },
  { "ign0", 0, 62, 1, &dtd_PSymbols[22], &dtd_PSymFrms[22], -1, -1 },
  { "nul", 0, 63, 0, (int*)NULL, (int*)NULL, -1, -1 },
  { "ign0", 0, 63, 1, &dtd_PSymbols[23], &dtd_PSymFrms[23], -1, -1 },
  { "pref", 0, 64, 1, &dtd_PSymbols[24], &dtd_PSymFrms[24], -1, -1 },
  { "lit", 0, 64, 1, &dtd_PSymbols[25], &dtd_PSymFrms[25], -1, -1 },
  { "nil", 0, 65, 0, (int*)NULL, (int*)NULL, -1, -1 },
  { "ign0", 0, 65, 3, &dtd_PSymbols[26], &dtd_PSymFrms[26], -1, -1 },
  { "nil", 0, 66, 0, (int*)NULL, (int*)NULL, -1, -1 },
  { "cons", 0, 66, 2, &dtd_PSymbols[29], &dtd_PSymFrms[29], -1, -1 },
  { "nil", 0, 67, 0, (int*)NULL, (int*)NULL, -1, -1 },
  { "cons", 0, 67, 2, &dtd_PSymbols[31], &dtd_PSymFrms[31], -1, -1 },
  { "pref", 0, 68, 1, &dtd_PSymbols[33], &dtd_PSymFrms[33], -1, -1 },
  { "pi", 0, 68, 1, &dtd_PSymbols[34], &dtd_PSymFrms[34], -1, -1 },
  { "elm", 0, 68, 5, &dtd_PSymbols[35], &dtd_PSymFrms[35], -1, -1 },
  { "ent", 0, 68, 4, &dtd_PSymbols[40], &dtd_PSymFrms[40], -1, -1 },
  { "attr", 0, 68, 5, &dtd_PSymbols[44], &dtd_PSymFrms[44], -1, -1 },
  { "note", 0, 68, 5, &dtd_PSymbols[49], &dtd_PSymFrms[49], -1, -1 },
  { "cond", 0, 69, 1, &dtd_PSymbols[54], &dtd_PSymFrms[54], -1, -1 },
  { "ign0", 0, 69, 1, &dtd_PSymbols[55], &dtd_PSymFrms[55], -1, -1 },
  { "cign", 0, 70, 1, &dtd_PSymbols[56], &dtd_PSymFrms[56], -1, -1 },
  { "cinc", 0, 70, 5, &dtd_PSymbols[57], &dtd_PSymFrms[57], -1, -1 },
  { "ccnd", 0, 70, 5, &dtd_PSymbols[62], &dtd_PSymFrms[62], -1, -1 },
  { "nil", 0, 71, 0, (int*)NULL, (int*)NULL, -1, -1 },
  { "cons", 0, 71, 2, &dtd_PSymbols[67], &dtd_PSymFrms[67], -1, -1 },
  { "nam", 0, 72, 1, &dtd_PSymbols[69], &dtd_PSymFrms[69], -1, -1 },
  { "typ", 0, 72, 1, &dtd_PSymbols[70], &dtd_PSymFrms[70], -1, -1 },
  { "dft", 0, 72, 1, &dtd_PSymbols[71], &dtd_PSymFrms[71], -1, -1 },
  { "str", 0, 73, 1, &dtd_PSymbols[72], &dtd_PSymFrms[72], -1, -1 },
  { "id", 0, 73, 1, &dtd_PSymbols[73], &dtd_PSymFrms[73], -1, -1 },
  { "ref", 0, 73, 1, &dtd_PSymbols[74], &dtd_PSymFrms[74], -1, -1 },
  { "refs", 0, 73, 1, &dtd_PSymbols[75], &dtd_PSymFrms[75], -1, -1 },
  { "ent", 0, 73, 1, &dtd_PSymbols[76], &dtd_PSymFrms[76], -1, -1 },
  { "ents", 0, 73, 1, &dtd_PSymbols[77], &dtd_PSymFrms[77], -1, -1 },
  { "nmt", 0, 73, 1, &dtd_PSymbols[78], &dtd_PSymFrms[78], -1, -1 },
  { "nmts", 0, 73, 1, &dtd_PSymbols[79], &dtd_PSymFrms[79], -1, -1 },
  { "ntyp", 0, 73, 1, &dtd_PSymbols[80], &dtd_PSymFrms[80], -1, -1 },
  { "etyp", 0, 74, 3, &dtd_PSymbols[81], &dtd_PSymFrms[81], -1, -1 },
  { "ign0", 0, 74, 1, &dtd_PSymbols[84], &dtd_PSymFrms[84], -1, -1 },
  { "req", 0, 75, 2, &dtd_PSymbols[85], &dtd_PSymFrms[85], -1, -1 },
  { "imp", 0, 75, 2, &dtd_PSymbols[87], &dtd_PSymFrms[87], -1, -1 },
  { "fix", 0, 75, 2, &dtd_PSymbols[89], &dtd_PSymFrms[89], -1, -1 },
  { "nul", 0, 76, 0, (int*)NULL, (int*)NULL, -1, -1 },
  { "fix", 0, 76, 2, &dtd_PSymbols[91], &dtd_PSymFrms[91], -1, -1 },
  { "pent", 0, 77, 3, &dtd_PSymbols[93], &dtd_PSymFrms[93], -1, -1 },
  { "gent", 0, 77, 2, &dtd_PSymbols[96], &dtd_PSymFrms[96], -1, -1 },
  { "ient", 0, 78, 1, &dtd_PSymbols[98], &dtd_PSymFrms[98], -1, -1 },
  { "eent", 0, 78, 2, &dtd_PSymbols[99], &dtd_PSymFrms[99], -1, -1 },
  { "nul", 0, 79, 0, (int*)NULL, (int*)NULL, -1, -1 },
  { "dfn", 0, 79, 2, &dtd_PSymbols[101], &dtd_PSymFrms[101], -1, -1 },
  { "pref", 0, 80, 1, &dtd_PSymbols[103], &dtd_PSymFrms[103], -1, -1 },
  { "none", 0, 80, 1, &dtd_PSymbols[104], &dtd_PSymFrms[104], -1, -1 },
  { "any", 0, 80, 1, &dtd_PSymbols[105], &dtd_PSymFrms[105], -1, -1 },
  { "mix", 0, 80, 1, &dtd_PSymbols[106], &dtd_PSymFrms[106], -1, -1 },
  { "ign0", 0, 80, 1, &dtd_PSymbols[107], &dtd_PSymFrms[107], -1, -1 },
  { "ign0", 0, 81, 3, &dtd_PSymbols[108], &dtd_PSymFrms[108], -1, -1 },
  { "cons", 0, 81, 4, &dtd_PSymbols[111], &dtd_PSymFrms[111], -1, -1 },
  { "nil", 0, 82, 0, (int*)NULL, (int*)NULL, -1, -1 },
  { "cons", 0, 83, 2, &dtd_PSymbols[115], &dtd_PSymFrms[115], -1, -1 },
  { "cons", 0, 84, 2, &dtd_PSymbols[117], &dtd_PSymFrms[117], -1, -1 },
  { "nil", 0, 85, 0, (int*)NULL, (int*)NULL, -1, -1 },
  { "cons", 0, 85, 3, &dtd_PSymbols[119], &dtd_PSymFrms[119], -1, -1 },
  { "pdat", 0, 86, 2, &dtd_PSymbols[122], &dtd_PSymFrms[122], -1, -1 },
  { "rexp", 0, 87, 3, &dtd_PSymbols[124], &dtd_PSymFrms[124], -1, -1 },
  { "alt", 0, 88, 3, &dtd_PSymbols[127], &dtd_PSymFrms[127], -1, -1 },
  { "seq", 0, 88, 3, &dtd_PSymbols[130], &dtd_PSymFrms[130], -1, -1 },
  { "ign0", 0, 88, 1, &dtd_PSymbols[133], &dtd_PSymFrms[133], -1, -1 },
  { "nam", 0, 89, 2, &dtd_PSymbols[134], &dtd_PSymFrms[134], -1, -1 },
  { "ign0", 0, 89, 1, &dtd_PSymbols[136], &dtd_PSymFrms[136], -1, -1 },
  { "star", 0, 90, 1, &dtd_PSymbols[137], &dtd_PSymFrms[137], -1, -1 },
  { "ign0", 0, 90, 2, &dtd_PSymbols[138], &dtd_PSymFrms[138], -1, -1 },
  { "nul", 0, 91, 0, (int*)NULL, (int*)NULL, -1, -1 },
  { "ign0", 0, 91, 1, &dtd_PSymbols[140], &dtd_PSymFrms[140], -1, -1 },
  { "qry", 0, 92, 1, &dtd_PSymbols[141], &dtd_PSymFrms[141], -1, -1 },
  { "star", 0, 92, 1, &dtd_PSymbols[142], &dtd_PSymFrms[142], -1, -1 },
  { "plus", 0, 92, 1, &dtd_PSymbols[143], &dtd_PSymFrms[143], -1, -1 },
  { "alst", 0, 93, 1, &dtd_PSymbols[144], &dtd_PSymFrms[144], -1, -1 },
  { "elm", 0, 93, 1, &dtd_PSymbols[145], &dtd_PSymFrms[145], -1, -1 },
  { "inc", 0, 93, 1, &dtd_PSymbols[146], &dtd_PSymFrms[146], -1, -1 },
  { "req", 0, 93, 1, &dtd_PSymbols[147], &dtd_PSymFrms[147], -1, -1 },
  { "fix", 0, 93, 1, &dtd_PSymbols[148], &dtd_PSymFrms[148], -1, -1 },
  { "impl", 0, 93, 1, &dtd_PSymbols[149], &dtd_PSymFrms[149], -1, -1 },
  { "pub", 0, 93, 1, &dtd_PSymbols[150], &dtd_PSymFrms[150], -1, -1 },
  { "sys", 0, 93, 1, &dtd_PSymbols[151], &dtd_PSymFrms[151], -1, -1 },
  { "none", 0, 93, 1, &dtd_PSymbols[152], &dtd_PSymFrms[152], -1, -1 },
  { "any", 0, 93, 1, &dtd_PSymbols[153], &dtd_PSymFrms[153], -1, -1 },
  { "pdat", 0, 93, 1, &dtd_PSymbols[154], &dtd_PSymFrms[154], -1, -1 },
  { "ktyp", 0, 94, 1, &dtd_PSymbols[155], &dtd_PSymFrms[155], -1, -1 },
  { "ign0", 0, 94, 1, &dtd_PSymbols[156], &dtd_PSymFrms[156], -1, -1 },
  { "ide", 0, 95, 1, &dtd_PSymbols[157], &dtd_PSymFrms[157], -1, -1 },
  { "nmtk", 0, 95, 1, &dtd_PSymbols[158], &dtd_PSymFrms[158], -1, -1 },
  { "key", 0, 95, 1, &dtd_PSymbols[159], &dtd_PSymFrms[159], -1, -1 },
  { "ign0", 0, 95, 1, &dtd_PSymbols[160], &dtd_PSymFrms[160], -1, -1 },
  { "ign1", 0, 95, 1, &dtd_PSymbols[161], &dtd_PSymFrms[161], -1, -1 },
  { "pref", 0, 96, 1, &dtd_PSymbols[162], &dtd_PSymFrms[162], -1, -1 },
  { "ign0", 0, 97, 1, &dtd_PSymbols[163], &dtd_PSymFrms[163], -1, -1 },
  { "ndat", 0, 97, 1, &dtd_PSymbols[164], &dtd_PSymFrms[164], -1, -1 },
  { "Start_Root", 0, 98, 1, &dtd_PSymbols[165], &dtd_PSymFrms[165], -1, -1 },
  { "Start_Embed", 0, 99, 1, &dtd_PSymbols[166], &dtd_PSymFrms[166], -1, -1 }
};

static int dtd_MstShifts[] = {
  2, 29, -1, 29, -1, -1, 59, -1, 
  -1, -1, -1, -1, -1, -1, -1, -1, 
  -1, -1, -1, -1, -1, -1, -1, -1, 
  -1, -1, -1, -1, -1, -1, -1, -1, 
  -1, -1, -1, 67, -1, -1, -1, -1, 
  -1, -1, -1, 74, 80, -1, -1, 59, 
  -1, -1, 84, 84, 87, -1, -1, -1, 
  29, 114, 29, 29, 141, 143, -1, -1, 
  -1, -1, 84, 147, 151, 156, 29, 161, 
  166, 197, 67, 225, 225, -1, -1, 227, 
  147, -1, -1, 255, -1, -1, 283, -1, 
  -1, 166, -1, 84, -1, 286, -1, -1, 
  29, 291, 295, 197, -1, -1, -1, 297, 
  -1, 299, 301, 303, -1, -1, 330, 357, 
  359, 361, -1, 364, 368, 373, -1, -1, 
  84, -1, 29, 377, 361, -1, -1, -1, 
  -1, -1, -1, -1, -1, -1, -1, -1, 
  29, -1, 379, 373, -1, -1, 330, 330, 
  -1, -1, -1, -1, -1, -1, -1, -1, 
  -1, 361, -1, -1, -1, -1, -1
};

static int dtd_DtlShifts[] = {
  -3, -4, 14, 5, -8, -9, -10, -11, 
  -12, -13, -14, -15, -16, -17, -18, -19, 
  -20, -21, -22, -23, -24, -25, -26, -27, 
  -28, -29, -30, -31, -32, 53, 48, 45, 
  44, 42, 41, 40, 36, 35, 34, 33, 
  32, 31, 30, 28, 26, 25, 24, 23, 
  19, 18, 12, 11, 4, 3, -41, -42, 
  -43, -44, -45, 27, 22, 15, 6, 3, 
  -50, -51, -52, 19, 18, 3, -57, -58, 
  -59, -60, 26, 25, 24, 23, -61, -62, 
  28, 3, -64, -65, 13, 3, -68, 20, 
  -8, -9, -10, -11, -12, -13, -14, -15, 
  -16, -17, -18, -19, -20, -21, -22, -23, 
  -24, -25, -26, -27, -28, -29, -30, -31, 
  -32, -71, 43, 53, 48, 45, 44, 42, 
  41, 40, 36, 35, 34, 33, 32, 31, 
  30, 28, 26, 25, 24, 23, 19, 18, 
  12, 11, 4, 3, -76, 20, -77, 20, 
  -41, -42, -44, 22, 6, 3, -82, 17, 
  -83, -84, -85, -86, 45, 44, 37, 3, 
  -91, 17, -51, -64, -65, -92, 19, 13, 
  3, 18, -8, -9, -10, -11, -12, -13, 
  -14, -15, -16, -17, -18, -19, -20, -21, 
  -22, -23, -24, -25, -26, -27, -28, -29, 
  -30, -31, -32, -97, -98, 39, 37, 53, 
  48, 45, 44, 42, 41, 40, 36, 35, 
  34, 33, 32, 31, 30, 28, 26, 25, 
  24, 23, 19, 18, 12, 11, 4, 3, 
  -3, 5, -109, 21, -8, -9, -10, -11, 
  -12, -13, -14, -15, -16, -17, -18, -19, 
  -20, -21, -22, -23, -24, -25, -26, -27, 
  -28, -29, -30, -31, -32, -111, -112, 39, 
  37, 53, 48, 45, 44, 42, 41, 40, 
  36, 35, 34, 33, 32, 31, 30, 28, 
  26, 25, 24, 23, 19, 18, 12, 11, 
  4, 3, -119, 17, -8, -32, 53, 3, 
  -126, -127, -128, 42, 41, 40, -129, 17, 
  -131, 13, -132, 17, -133, 29, -134, 29, 
  -8, -9, -10, -11, -12, -13, -14, -15, 
  -16, -17, -18, -19, -20, -21, -22, -23, 
  -24, -25, -26, -27, -28, -29, -30, -31, 
  -32, -111, 37, 53, 48, 45, 44, 42, 
  41, 40, 36, 35, 34, 33, 32, 31, 
  30, 28, 26, 25, 24, 23, 19, 18, 
  12, 11, 4, 3, -135, 48, -136, 38, 
  -137, 47, -140, -141, 46, 38, -143, -144, 
  49, 47, -145, -146, -147, 52, 51, 50, 
  -152, 38, -155, 46
};

static int dtd_GoTos[] = {
  0, 2, 6, 12, 16, 18, 21, 27, 
  31, 34, 36, 49, 51, 55, 59, 65, 
  68, 71, 75, 78, 96, 99, 102, 105, 
  107, 111, 113, 115, 117, 119, 121, 123, 
  129, 131, 138, 145, 150, 152, 156, 159, 
  176, 200, 218, 236
};

static int dtd_GoToDfts[] = {
  164, -1, 192, 2, 199, 4, 165, 1, 
  266, 76, 267, 77, 166, -1, -76, -77, 
  212, -36, 213, -36, -75, 214, 36, 75, 
  252, 73, 90, 215, 36, 265, 75, 253, 
  -73, -90, 237, -67, 225, 51, 226, 52, 
  238, 67, 254, 73, 90, 280, 92, 309, 
  121, 228, -53, 239, 68, 269, 81, 205, 
  7, 222, 48, 206, 7, 48, 240, 68, 
  81, 207, -7, -48, 208, -7, -48, 258, 
  74, 289, 100, 259, -74, -100, 193, 2, 
  4, 57, 58, 59, 60, 71, 84, 97, 
  111, 123, 137, 143, 144, 260, 74, 100, 
  261, -74, -100, 262, -74, -100, 263, -74, 
  -100, 231, -58, 255, 73, 279, 90, 281, 
  -94, 246, -70, 247, -70, 297, -114, 283, 
  -97, 272, -84, 298, 114, 312, 125, 318, 
  154, 273, -84, 248, 70, 274, 84, 111, 
  143, 144, 275, 84, 111, 316, 143, 317, 
  144, 276, -84, -111, -143, -144, 301, -116, 
  307, 118, 315, 140, 308, -118, -140, 194, 
  -2, -4, -57, -58, -59, -60, -71, -74, 
  -84, -97, -100, -111, -123, -137, -143, -144, 
  195, 2, 4, 229, 57, 232, 58, 233, 
  59, 234, 60, 249, 71, 277, 84, 111, 
  143, 144, 284, 97, 310, 123, 313, 137, 
  196, 2, 4, 57, 58, 59, 60, 71, 
  84, 97, 111, 123, 137, 143, 144, 264, 
  74, 100, 197, -2, -4, -57, -58, -59, 
  -60, -71, -74, -84, -94, -97, -100, -111, 
  -123, -137, -143, -144, 198, 2, 4, 57, 
  58, 59, 60, 71, 74, 84, 97, 100, 
  111, 123, 137, 143, 144, 282, 94
};

static int dtd_ActDfts[] = {
  5, 113, 6, 113, 114, 2, 24, 108, 
  104, 105, 103, 97, 96, 91, 46, 90, 
  50, 92, 42, 43, 44, 45, 47, 48, 
  49, 93, 95, 94, 98, 99, 100, 110, 
  114, 101, 106, 7, 102, 109, 107, 1, 
  26, 27, 34, 113, 113, 4, 33, 24, 
  32, 9, 113, 113, 20, 13, 12, 8, 
  113, 113, 113, 113, 113, 113, 25, 18, 
  19, 10, 16, 22, 113, 113, 113, 113, 
  113, 0, 113, 5, 5, 11, 17, 113, 
  22, 3, 64, 113, 65, 66, 113, 67, 
  68, 113, 29, 113, 15, 62, 60, 59, 
  113, 113, 113, -4, 52, 40, 41, 113, 
  39, 113, 113, 113, 21, 23, 113, 113, 
  113, -8, 82, 113, 80, 85, 28, 58, 
  113, 61, 113, 113, 74, 53, 54, 57, 
  30, 38, 55, 31, 36, 35, 76, 69, 
  113, 73, 113, 85, 83, 77, 113, 113, 
  87, 88, 89, 81, 86, 14, 63, 51, 
  72, 74, 70, 84, 78, 79, 75
};

static int dtd_ActExps[] = {
  205, 18, 224, 14, -205, -18, -224, -14, 
  239, 39, 242, 47
};

static PARSETAB dtd_ParseTab = {
  &dtd_KfgHead, 112, dtd_KfgProds,
  {
    159, dtd_MstShifts, 380, dtd_DtlShifts,
    44, dtd_GoTos, 255, dtd_GoToDfts,
    159, dtd_ActDfts, 12, dtd_ActExps
  }
};

PLR_Tab PLR_get_dtd()
/* simulates a PLR_getTab */
{
  return( PLR_copyTab(&dtd_ParseTab) );
}
